<#

	Describe here what this is all about
	+ version histrory
	+ etc
	
	2DO: If category = version: show lastr version
	
		$msg= ($A | Where { $_.Category -eq "Version"} | select Description -last 1)
		$msg.Description

		
============= Version 2: ============= 

	
*	2DO: Make VB dialog on top (currently not active)

*	In a later version:
	First all project dialogs, then copying (background).
	Only if something goes wrong, popup again.
	
*	Add helptext


*	2DO: Handle new, empty project


Run the unattended mode (for scheduled tasks etc( wu=ith command:

Powershell.exe -File "C:\Path\To\Your\Snap-In.ps1" -autosave


#>



#_______________________________________________
#
#	PARAMETER HANDLING
#_______________________________________________
#

	param (
		[switch]$AutoSave = $false
	)




#_______________________________________________
#
#	SETTINGS
#_______________________________________________
#


#	What folder, containing 'projects', should be backed-up?
	$WatchFolder = "c:\develop"

#	Where should these backups land?
	$Repository = "C:\temp\develop"

#	When backupped, you have to categorize the changes
#	These are the categories  (sorted by estimated usage frequency) :
#	??? Add autosave to interactive categories?
	$Menu = @(
	'Researching'
	'Working on'
	'Milestone'
	'Version'
	'Ignore'
	'New'
	)



#_______________________________________________
#
#	INIT
#_______________________________________________
#


  # 2DO: unset all variables
  # 2DO: check for Everything.exe
  # 2DO: check for right PowerShell version ( >= 3.0)


  #	Make the script folder the working directory
  #	(easier to find files/programs that way)

	set-location $PSScriptRoot

	
  #	Clean up $WatchFolder and $Repository directory name
  #	Don't trim \ at the front, because of \\server\share or \\?\C:...

	$WatchFolder = $WatchFolder.TrimEnd("\`" ").Trim("`"")
	$Repository = $Repository.TrimEnd("\`" ").Trim("`"")


  #	Load Visual Basic 'interaction'
  #	Needed for showing GUI elements (InputBox, MsgBox)

	$null = [Reflection.Assembly]::LoadWithPartialName('Microsoft.VisualBasic')


  #	Current date/time in '2018-01-31  23.59.59' format
  #	Used for foldernames; all projects in this backup get the same timestamp.
			
	$Now = (date).ToString("yyyy-MM-dd  HH.mm.ss")

  #	Give window a unique title to spot alredy running backups
	$WindowTitle = "Snap-In already running"




#_______________________________________________
#
#	GO!
#_______________________________________________


#-----------------------------------------------
#	ALREADY RUNNING?
#-----------------------------------------------

#	Check if there is a powershell porocess with title "Snap-In"
	$ALREADY = ( Get-Process powershell | Where { ($_.MainWindowTitle -eq $WindowTitle) } )


	if ( $ALREADY ) { # Snap-In already running

		if ($AutoSave) { # if we are running from scheduled task: quit
			# TEST echo "QUIT" ; cmd /c pause
			EXIT
		} else {	# In interactive mode
			echo "Another Snap-In job is already running"
			echo ( "since " + $ALREADY.StartTime.DateTime )
			echo ( " ( " + ( New-TimeSpan -start $ALREADY.StartTime ).ToString("hh\:mm\:ss") + " hours ago )")
			# 2DO: Figure out how to handle this case
			echo ''
			echo "Fix that first!!"
			cmd /c pause
			EXIT
		}
	}

# Change title to "Snap-In already running" (for easy detection)
# Save the current title, to restore it at the end

	$OrgTitle = $host.ui.RawUI.WindowTitle
	$host.ui.RawUI.WindowTitle = $WindowTitle


	
	
#-----------------------------------------------
#	LOOP THROUGH EACH PROJECT FOLDER
#-----------------------------------------------

	gci -Path $WatchFolder -dir | % {

	
		$ThisProject = $_.Name
		echo [$ThisProject]

	  # Get some information about the index
		$EFUPath = $Repository + "\" + $ThisProject + "\Index"
	  # Indexfile for timestamp, categories, descriptions
		$CSV = $EFUPath + "\Descriptions.csv"

	#-----------------------------------------------
	#	GET LAST STATE
	#-----------------------------------------------
		
		#$MostRecentCategory = ( import-csv $CSV | select -last 1).Category
		#[bool]$MostRecentAutoSave = ( $MostRecentCategory -eq "AutoSave" ) 


		IF (Test-Path $EFUPath) {
		  #---------------------------------------------------------------
		  #		Existing project
		  #---------------------------------------------------------------

		  # Get the content of the last scan (= most recent EFU file)
			$MostRecentEFU = gc ( (gi "$EFUPath\*.efu") | sort Name -Descending | select -First 1)

		} ELSE {
		  #---------------------------------------------------------------
		  #		New project
		  #---------------------------------------------------------------
		
		  #	If this is a new "project", we have to do some housekeeping,
		  #	like creating a folderstructure

		  # Create folder for this project
			$null = md $EFUPath
			# 2DO: + errorchecking/-logging

		  # Create header for Descriptions.csv
			echo "`"Folder`",`"Category`",`"Description`"" | Out-File -Encoding UTF8 $CSV
		
		  # There is no previous scan, so instead feed it an empty EFU file to compare against
			$MostRecentEFU = "Filename,Size,Date Modified,Date Created,Attributes"
		}

		$MostRecentCategory = ( import-csv $CSV | select -last 1).Category
		[bool]$MostRecentAutoSave = ( $MostRecentCategory -eq "AutoSave" ) 
	
		
		
	#-----------------------------------------------
	#	GET CURRENT STATE
	#-----------------------------------------------
		
	  #	Create snapshot using Everything's EFU file structure

		$NowEFU = $EFUPath + "\" + $NOW + ".efu"
		Start -Wait -FilePath .\Everything.exe -ArgumentList "-createfilelist `"$NOWEFU`" `"$($_.FullName)`""


	#-----------------------------------------------
	#	COMPARE LAST STATE VS CURRENT STATE
	#-----------------------------------------------
			
		$NowEFU = gi $NowEFU
		$Diff = compare ($MostRecentEFU) (gc $NowEFU)



	#-----------------------------------------------
	#	DECIDE WHAT TO DO WITH DELTA
	#-----------------------------------------------

		<#
		A = $AutoSave
		B = $Diff
		C = $MostRecentCategory = "AutoSave"

		 A B C	Action
		--+-+-+---------------------- 
		 0 0 0	Nothing, delete EFU
		 0 0 1	Dialog
		 0 1 0	Dialog
		 0 1 1	Dialog
		 1 0 0	Nothing, delete EFU
		 1 0 1	Nothing, delete EFU
		 1 1 0	Decription = AutoSave 
		 1 1 1	Decription = AutoSave 
		#>

		IF (!$Diff) { 
			IF ( !$AutoSave -and $MostRecentAutoSave ) {
				$DeltaAction = "Dialog"
			} ELSE {
				$DeltaAction = "Nothing"
			}
		} ElseIf ($AutoSave) {
				$DeltaAction = "AutoSave"
		} Else {
			$DeltaAction = "Dialog"
		}

	#-----------------------------------------------
	#	... WRITE INDEX FILES (OR NOT) BASED ON DELTA DECISION
	#-----------------------------------------------

#cmd /c pause
		Switch ($DeltaAction) {
	   "Nothing" { 
		  # No need to copy anything, so return ( = next project)
			del $NowEFU
			# 2DO: unset all variables from THIS PROJECT
			# 2DO: More accurate alternative for return? ..
			RETURN
		   }
	   "AutoSave" {
			# Write input to descriptions.csv
			echo "`"$Now`",`"AutoSave`",`"---`"" | Out-File -Encoding UTF8 -append $CSV
			}
		"Dialog" {
			
			#	Select category (see SETTINGS section)

				$Category = $Menu | ogv -Outputmode Single -Title "$ThisProject - Select category"

			# Inputbox voor description

				$title = "$ThisProject : Describe the changes"
				$msg   = $Category + " : "
				$Description = [Microsoft.VisualBasic.Interaction]::InputBox($msg, $title)

			
			# Write input to descriptions.csv
				echo "`"$Now`",`"$Category`",`"$Description`"" | Out-File -Encoding UTF8 -append $CSV

				echo "$Category `: $Description"
				echo "New/changed files `:"

			}
	   }


#cmd /c pause
		
		

	#-----------------------------------------------
	#	... AND COPY THE FILES (OR NOT) BASED ON DELTA DECISION
	#-----------------------------------------------


	  #	The output of Compare is something like:
	  #
	  #		InputObject                             SideIndicator
	  #		-----------                             -------------
	  #		"c:\temp\test.txt\cmd.lnk",1212,1218... =>
	  #		"c:\temp\test.txt\cmd.lnk",1212,1318... <=
	  #
	  #	We need the new or changed files (sideindicator '=>') and are omnly interested in the filename itself
	  #	Those files should be copied to the $Repository (conserving the directory structure)
	  #
	  #	Example:
	  #	Source: "c:\Develop\Project1\Research\test.txt"
	  #	Destination: "D:\repository\Project1\2018-01-01T12.34.56\Research\test.txt"

#cmd /c pause
	
	
		$Diff | where { $_.SideIndicator -eq '=>' } | % {

			$CopyFromFile = ($_.InputObject.ToString() -split ",")[0]
			$CopyFromFile = $CopyFromFile.Trim("`"")
			echo "==`> $CopyFromFile"
			
		  # Replace Source path with Target path
			$CopyToFile	= $Repository + "\" + $ThisProject + "\" + $Now + "\" + $CopyFromFile.Substring( $WatchFolder.Length + $ThisProject.Length +2 )
		
		  #	Create directory for $CopyToFile (if needed)
			IF ( -not (Test-Path $CopyToFile\..)) { $null = md "$CopyToFile\.." }

		  # And copy the file
			$CopyFromFile = gi $CopyFromFile
			copy $CopyFromFile $CopyToFile
			# 2DO: + errorchecking/-logging
		}

	  #---------------------------------------------------------------
	  #		End of this Project. Up to the next one .. 
	  #---------------------------------------------------------------

	  # 2DO: unset all variables from THIS PROJECT
#cmd /c pause
	}

	
	
	
	
#---------------------------------------------------------------
#		WE'RE DONE WITH ALL PROJECT FOLDERS. WRAPPING UP.
#---------------------------------------------------------------
#	

#	Restore original Window title
	$host.ui.RawUI.WindowTitle = $OrgTitle

#	Show message
	if (-not $AutoSave ) {
		[Microsoft.VisualBasic.Interaction]::MsgBox('Ready !!',0,'Snap-In') }  
	
# 2DO: Write a lastchecked flag file, so we know when script was run for the last time


#TEST
#cmd /c pause
